UI libraries / Angular InstantSearch / Widgets
Signature
<ais-search-box
  // Optional parameters
  placeholder="string"
  submitTitle="string"
  resetTitle="string"
  [searchAsYouType]="boolean"
  [autofocus]="boolean"
  [showLoadingIndicator]="boolean"
></ais-search-box>
Import
1
2
3
4
5
6
7
8
import { NgAisSearchBoxModule } from 'angular-instantsearch';

@NgModule({
  imports: [
    NgAisSearchBoxModule,
  ],
})
export class AppModule {}

1. Follow additional steps in Optimize build size to ensure your code is correctly bundled.
2. This imports all the widgets, even the ones you don’t use. Read the Getting started guide for more information.

About this widget

The ais-search-box widget is used to let the user set a text-based query.

This usually is the main entry point to start search in an InstantSearch context. Most of the time, it is placed at the top of a search experience, so that the user can start searching right away.

Examples

1
<ais-search-box></ais-search-box>

Props

placeholder
type: string
default: Search
Optional

The input placeholder.

1
2
3
<ais-search-box
  placeholder="Search for products..."
></ais-search-box>
submitTitle
type: string
default: Submit
Optional

The submit button text.

1
2
3
<ais-search-box
  submitTitle="Go"
></ais-search-box>
resetTitle
type: string
default: Reset
Optional

The clear button text.

1
2
3
<ais-search-box
  resetTitle="Clear"
></ais-search-box>
searchAsYouType
type: boolean
default: true
Optional

Whether a search needs to be made on every change to the query. If false, new searches are only triggered by clicking the search button or by pressing the Enter key while the search box is focused.

1
2
3
<ais-search-box
  [searchAsYouType]="false"
></ais-search-box>
autofocus
type: boolean
default: false
Optional

Whether to automatically focus on the input when rendered.

1
2
3
<ais-search-box
  [autofocus]="true"
></ais-search-box>
showLoadingIndicator
type: boolean
default: true
Optional

Displays an indicator that the search is loading. The loading indicator is only shown if Algolia doesn’t return the search results within a time limit. On faster network connections, this avoids unnecessarily rendering the loading indicator on every keystroke, while on slower connections, it provides good user feedback. You can adjust the time limit before rendering the loading indicator with the stalledSearchDelay parameter on the ais-instantsearch component.

1
2
3
<ais-search-box
  [showLoadingIndicator]="false"
></ais-search-box>

HTML output

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
<div class="ais-SearchBox">
  <form class="ais-SearchBox-form" novalidate>
    <input class="ais-SearchBox-input" autocomplete="off" autocorrect="off" autocapitalize="off" placeholder="Search for products" spellcheck="false" maxlength="512" type="search" value="" />
    <button class="ais-SearchBox-submit" type="submit" title="Submit the search query.">
      <svg class="ais-SearchBox-submitIcon" xmlns="http://www.w3.org/2000/svg" width="10" height="10" viewBox="0 0 40 40">
        ...
      </svg>
    </button>
    <button class="ais-SearchBox-reset" type="reset" title="Clear the search query." hidden>
      <svg class="ais-SearchBox-resetIcon" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" width="10" height="10">
        ...
      </svg>
    </button>
    <span class="ais-SearchBox-loadingIndicator" hidden>
      <svg width="16" height="16" viewBox="0 0 38 38" xmlns="http://www.w3.org/2000/svg" stroke="#444" class="ais-SearchBox-loadingIcon">
        ...
      </svg>
    </span>
  </form>
</div>

Customize the UI with connectSearchBox

If you want to create your own UI of the ais-search-box widget, you can combine the connectSearchBox connector with the TypedBaseWidget class.

1. Extend the TypedBaseWidget class

First of all, you will need to write some boilerplate code to initialize correctly the TypedBaseWidget class. This happens in the constructor() of your class extending the TypedBaseWidget class.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
import { Component, Inject, forwardRef, Optional } from '@angular/core';
import { TypedBaseWidget, NgAisInstantSearch, NgAisIndex } from 'angular-instantsearch';

@Component({
  selector: 'app-search-box',
  template: '<p>It works!</p>'
})
export class SearchBox extends TypedBaseWidget {
  constructor(
    @Inject(forwardRef(() => NgAisIndex))
    @Optional()
    public parentIndex: NgAisIndex,
    @Inject(forwardRef(() => NgAisInstantSearch))
    public instantSearchInstance: NgAisInstantSearch
  ) {
    super('SearchBox');
  }
}

There are a couple of things happening in this boilerplate:

  • create a SearchBox class extending TypedBaseWidget
  • reference the <ais-instantsearch> parent component instance on the SearchBox widget class
  • set app-search-box as a selector, so we can use our component as <app-search-box></app-search-box>

2. Connect your custom widget

The TypedBaseWidget class has a method called createWidget() which takes two arguments: the connector to use and an object of options (instance options) for this connector. We call this method at ngOnInit. This component now implements OnInit.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
import { Component, Inject, forwardRef, Optional } from '@angular/core';
import { TypedBaseWidget, NgAisInstantSearch, NgAisIndex } from 'angular-instantsearch';

import connectSearchBox, {
  SearchBoxWidgetDescription,
  SearchBoxConnectorParams
} from 'instantsearch.js/es/connectors/search-box/connectSearchBox';

@Component({
  selector: 'app-search-box',
  template: '<p>It works!</p>'
})
export class SearchBox extends TypedBaseWidget<SearchBoxWidgetDescription, SearchBoxConnectorParams> {
  public state: SearchBoxWidgetDescription['renderState']; // Rendering options
  constructor(
    @Inject(forwardRef(() => NgAisIndex))
    @Optional()
    public parentIndex: NgAisIndex,
    @Inject(forwardRef(() => NgAisInstantSearch))
    public instantSearchInstance: NgAisInstantSearch
  ) {
    super('SearchBox');
  }
  ngOnInit() {
    this.createWidget(connectSearchBox, {
      // instance options
    });
    super.ngOnInit();
  }
}

3. Render from the state

Your component instance has access to a this.state property which holds the rendering options of the widget.

public state: SearchBoxWidgetDescription['renderState'];
// {
//   query: string;
//   refine: Function;
//   clear: Function;
//   isSearchStalled: boolean;
//   widgetParams: object;
// }
1
2
3
4
5
6
<input
  type="text"
  #input
  (keyup)="this.state.refine(input.value)"
  [value]="this.state.query"
/>

Rendering options

query
type: string

The query from the current search.

refine
type: function

Sets a new query and triggers a new search.

clear
type: function

Removes the query and triggers a new search.

isSearchStalled
type: boolean

Returns true if the search results take more than a certain time to come back from Algolia servers. This can be configured on the instantsearch constructor with the stalledSearchDelay attribute.

widgetParams
type: object

All original widget options forwarded to the render function.

Instance options

queryHook
type: function
Optional

A function that is called just before the search is triggered. It takes two arguments:

  • query: string: the current query string
  • search: function: triggers the search

If the search method is not called, no search is made to Algolia and the UI doesn’t refresh. If the search method is called, the widget is rendered.

This can be useful if you need to:

  • Debounce the number of searches done from the searchBox. You can find more information in the guide on slow network.
  • Programmatically alter the query.

Full example

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
import { Component, Inject, forwardRef, Optional } from '@angular/core';
import { TypedBaseWidget, NgAisInstantSearch, NgAisIndex } from 'angular-instantsearch';

import connectSearchBox, {
  SearchBoxWidgetDescription,
  SearchBoxConnectorParams
} from 'instantsearch.js/es/connectors/search-box/connectSearchBox';

@Component({
  selector: 'app-search-box',
  template: `
<input
  type="text"
  #input
  (keyup)="this.state.refine(input.value)"
  [value]="this.state.query"
/>
`
})
export class SearchBox extends TypedBaseWidget<SearchBoxWidgetDescription, SearchBoxConnectorParams> {
  public state: SearchBoxWidgetDescription['renderState']; // Rendering options
  constructor(
    @Inject(forwardRef(() => NgAisIndex))
    @Optional()
    public parentIndex: NgAisIndex,
    @Inject(forwardRef(() => NgAisInstantSearch))
    public instantSearchInstance: NgAisInstantSearch
  ) {
    super('SearchBox');
  }
  ngOnInit() {
    this.createWidget(connectSearchBox, {
      // instance options
    });
    super.ngOnInit();
  }
}
Did you find this page helpful?

Skip to main content
This is the React InstantSearch v7 documentation. If you’re upgrading from v6, see the upgrade guide. If you were using React InstantSearch Hooks, this v7 documentation applies—just check for necessary changes. To continue using v6, you can find the archived documentation.
Signature
<SearchBox
  // Optional props
  placeholder={string}
  queryHook={function}
  ignoreCompositionEvents={boolean}
  searchAsYouType={boolean}
  autoFocus={boolean}
  onSubmit={function}
  submitIconComponent={() => JSX.Element}
  resetIconComponent={() => JSX.Element}
  loadingIconComponent={() => JSX.Element}
  classNames={object}
  translations={object}
  ...props={ComponentProps<'div'>}
/>

Import

JavaScript
import { SearchBox } from "react-instantsearch";

About this widget

<SearchBox> is a widget to let users perform a text-based query. The search box usually is the main entry point to start the search on an InstantSearch page. You typically place it at the top of a search experience so that users can start searching right away.
You can also create your own UI with useSearchBox.

Examples

JavaScript
import React from "react";
import { liteClient as algoliasearch } from "algoliasearch/lite";
import { InstantSearch, SearchBox } from "react-instantsearch";

const searchClient = algoliasearch("YourApplicationID", "YourSearchOnlyAPIKey");

function App() {
  return (
    <InstantSearch indexName="instant_search" searchClient={searchClient}>
      <SearchBox />
    </InstantSearch>
  );
}

Props

placeholder
string
The placeholder text of the input.
JavaScript
<SearchBox placeholder="Search for products" />;
queryHook
(query: string, search: (value: string) => void) => void
Function called every time the query changes. It takes two parameters:
  • query: The current query.
  • search: The function to trigger the search.
This prop can be useful if you need to:
  • Debounce searches to regulate requests.
  • Programmatically alter the query before sending it to Algolia.
When using this prop, you’re responsible for triggering the search with search. If you don’t call this function, no search is triggered to Algolia.
const queryHook = (query, search) => {
  search(query);
};

function Search() {
  return <SearchBox queryHook={queryHook} />;
}
ignoreCompositionEvents
boolean
default:false
since: v7.5.4
Whether to update the search state in the middle of a composition session. This is useful when users need to search using non-latin characters.
JavaScript
<SearchBox ignoreCompositionEvents />;
searchAsYouType
boolean
default:true
Whether to make a search on every change to the query. If false, new searches are only triggered by clicking the search button or by pressing the Enter key while focusing the search box.
JavaScript
<SearchBox searchAsYouType={false} />;
autoFocus
boolean
default:false
Whether the input should be autofocused.
JavaScript
<SearchBox autoFocus />;
onSubmit
(event: React.FormEvent<HTMLFormElement>) => void
A callback to run when submitting the form of the search box.
JavaScript
<SearchBox
  onSubmit={(event) => {
    // Code to run when the form submits
  }}
/>;
submitIconComponent
(props: IconProps) => JSX.Element
A component to replace the icon in the submit button.The component receives the passed classNames prop.
JavaScript
<SearchBox
  submitIconComponent={({ classNames }) => (
    <div className={classNames.submitIcon}>Submit</div>
  )}
/>;
resetIconComponent
(props: IconProps) => JSX.Element
A component to replace the icon in the reset button.The component receives the passed classNames prop.
JavaScript
<SearchBox
  resetIconComponent={({ classNames }) => (
    <div className={classNames.resetIcon}>Reset</div>
  )}
/>;
loadingIconComponent
(props: IconProps) => JSX.Element
A component to replace the loading icon.The component receives the passed classNames prop.
JavaScript
<SearchBox
  loadingIconComponent={({ classNames }) => (
    <div className={classNames.loadingIcon}>Loading</div>
  )}
/>;
classNames
Partial<SearchBoxClassNames>
The CSS classes you can override and pass to the widget’s elements. It’s useful to style widgets with class-based CSS frameworks like Bootstrap or Tailwind CSS.
  • root. The root element of the widget.
  • form. The form element.
  • input. The input element.
  • submit. The submit button.
  • reset. The reset button.
  • loadingIndicator. The loading indicator element.
  • submitIcon. The submit icon.
  • resetIcon. The reset icon.
  • loadingIcon. The loading icon.
JavaScript
<SearchBox
  classNames={{
    root: "MyCustomSearchBox",
    form: "MyCustomSearchBoxForm MyCustomSearchBoxForm--subclass",
  }}
/>;
translations
Partial<SearchBoxTranslations>
A dictionary of translations to customize the UI text and support internationalization.
  • submitButtonTitle. The submit button’s title.
  • resetButtonTitle. The reset button’s title.
JavaScript
<SearchBox
  translations={{
    submitButtonTitle: "Search",
    resetButtonTitle: "Reset",
  }}
/>;
...props
React.ComponentProps<'div'>
Any <div> prop to forward to the root element of the widget.
JavaScript
<SearchBox className="MyCustomSearchBox" title="My custom title" />;

Hook

React InstantSearch let you create your own UI for the <SearchBox> widget with useSearchBox. Hooks provide APIs to access the widget state and interact with InstantSearch. The useSearchBox Hook accepts parameters and returns APIs. It must be used inside the <InstantSearch> component.

Usage

First, create your React component:
JavaScript
import { useSearchBox } from "react-instantsearch";

function CustomSearchBox(props) {
  const { query, refine, clear } = useSearchBox(props);

  return <>{/*Your JSX*/}</>;
}
Then, render the widget:
JavaScript
<CustomSearchBox {...props} />;

Parameters

Hooks accept parameters. You can either pass them manually or forward props from a custom component.
When passing functions to Hooks, ensure stable references to prevent unnecessary re-renders. Use useCallback() for memoization. Arrays and objects are automatically memoized.
queryHook
(query: string, hook: (value: string) => void) => void
Function called every time the query changes.See queryHook for detail.
const queryHook = (query, search) => {
  search(query);
};

function SearchBox() {
  const searchBoxApi = useSearchBox({
    // ...
    queryHook,
  });

  return <>{/*Your JSX*/}</>;
}

APIs

Hooks return APIs, such as state and functions. You can use them to build your UI and interact with React InstantSearch.
query
string
The query from the last search.
refine
(value: string) => void
Sets a new query and searches.
clear
() => void
Clears the query and searches.
isSearchStalled
boolean
deprecated
Use status from useInstantSearch instead.
Whether the search results take more than a certain time to come back from Algolia servers.This can be configured on <InstantSearch> with the stalledSearchDelay props which defaults to 200 ms.

Example

import React, { useState, useRef } from "react";
import { useInstantSearch, useSearchBox } from "react-instantsearch";

function CustomSearchBox(props) {
  const { query, refine } = useSearchBox(props);
  const { status } = useInstantSearch();
  const [inputValue, setInputValue] = useState(query);
  const inputRef = useRef(null);

  const isSearchStalled = status === "stalled";

  function setQuery(newQuery) {
    setInputValue(newQuery);

    refine(newQuery);
  }

  return (
    <div>
      <form
        action=""
        role="search"
        noValidate
        onSubmit={(event) => {
          event.preventDefault();
          event.stopPropagation();

          if (inputRef.current) {
            inputRef.current.blur();
          }
        }}
        onReset={(event) => {
          event.preventDefault();
          event.stopPropagation();

          setQuery("");

          if (inputRef.current) {
            inputRef.current.focus();
          }
        }}
      >
        <input
          ref={inputRef}
          autoComplete="off"
          autoCorrect="off"
          autoCapitalize="off"
          placeholder="Search for products"
          spellCheck={false}
          maxLength={512}
          type="search"
          value={inputValue}
          onChange={(event) => {
            setQuery(event.currentTarget.value);
          }}
          autoFocus
        />
        <button type="submit">Submit</button>
        <button
          type="reset"
          hidden={inputValue.length === 0 || isSearchStalled}
        >
          Reset
        </button>
        <span hidden={!isSearchStalled}>Searching…</span>
      </form>
    </div>
  );
}